<?php

/**
 * Project:     Ant: sources.list generator
 * File:        admin.php
 *
 * This application is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


require_once dirname(__FILE__)."/sign-valid.php";

$mode = $secure->wrapInt($_GET["mode"]);
$act  = $secure->wrapInt($_GET["action"]);
$uid  = $secure->wrapInt($_GET["uid"]);
$err  = $secure->wrapInt($_GET["error"]);

// Admin file/interface
$admin = "./admin.php";
$imgdir = "./themes/icons/".$theme->getIconSetName($core,$db);

switch ($err) {
    case '1':
            $error = _("Password error: the password is incorrect!");
            break;
    case '2':
            $error = _("Password error: new passwords do not match!");
            break;
}

$header = "<div id='head'><div class='title'>".$core->getSetting('codename',$db)." Admin Panel</div><div class='smalltitle'>version: ".$core->getSetting('version',$db)."</div></div>";

$login = "<div id='login'>"._("You are logged as").": <b>".$login."</b> <a  class='dashed' href='./signout.php' style='color:red;'>["._("exit")."]</a></div>";


$menu_title = array ( _("Management"), _("References"), _("Preferences") );
$menu_item = array (
1 => array ( "title" => $menu_title[1], "item" => _("Distributives") ),
2 => array ( "title" => $menu_title[1], "item" => _("Versions") ),
3 => array ( "title" => $menu_title[1], "item" => _("Sources") ),
4 => array ( "title" => $menu_title[0], "item" => _("Repositories") ),
5 => array ( "title" => $menu_title[1], "item" => _("Sections") ),
6 => array ( "title" => $menu_title[1], "item" => _("Schemes") ),
7 => array ( "title" => $menu_title[1], "item" => _("Types") ),
9 => array ( "title" => $menu_title[1], "item" => _("Mirrors") ),
20 => array ( "title" => $menu_title[2], "item" => _("Options") ),
21 => array ( "title" => $menu_title[2], "item" => _("Interfaces") ),
22 => array ( "title" => $menu_title[2], "item" => _("Password") ),
23 => array ( "title" => $menu_title[2], "item" => _("Theme") ),
);

$menu = "
<div id='cont'>
<div id='menu'>
    <div class='menutitle'>".$menu_title[0].":</div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=4'>".$menu_item[4]["item"]."</a></div>
    <div class='menutitle'>".$menu_title[1].":</div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=9'>".$menu_item[9]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=1'>".$menu_item[1]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=2'>".$menu_item[2]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=3'>".$menu_item[3]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=5'>".$menu_item[5]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=6'>".$menu_item[6]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=7'>".$menu_item[7]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=8'>".$menu_item[8]["item"]."</a></div>
    <div class='menutitle'>".$menu_title[2].":</div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=20'>".$menu_item[20]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=21'>".$menu_item[21]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=22'>".$menu_item[22]["item"]."</a></div>
	<div class='menuitem'><a class='dashed' href='".$admin."?mode=23'>".$menu_item[23]["item"]."</a></div>
</div>
<div id='main'>
";

switch ($mode) {
    case '1':
	    // Работа с дистрибутивами
	    switch ($act) {
		case '0':
			// Список дистрибутивов
			$dist =& $db->query("SELECT * FROM distribution");
			if ($dist->numRows()>0) {
				$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
				$display .= "<table><tr><th>"._("Distributive")."</th><th>"._("Action")."</th><th>"._("Versions")."</th></tr>";
				while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
				    $verlist = "";
				    $sreq =& $db->query("SELECT * FROM version WHERE dist_id='".$info["dist_id"]."'");
				    while ($sreq->fetchInto($sinfo, DB_FETCHMODE_ASSOC)) {
				    $verlist .= "<em>".$secure->stripStr($sinfo["vname"])."</em>, ";
				    }
				    $verlist = substr($verlist, 0, -2);
				    $display .= "<tr><td>".$secure->stripStr($info['distname'])."</td>";
				    $display .= "<td><a href=".$admin."?mode=".$mode."&action=2&uid=".$info["dist_id"]."><img title='"._("Edit")."' src='$imgdir/edit.png' width='16' height='16'></a>";
				    $display .= "<a href=".$admin."?mode=".$mode."&action=3&uid=".$info["dist_id"]."><img title='"._("Remove")."' src='$imgdir/delete.png' width='16' height='16'></a></td>";
				    $display .= "<td>".$verlist."</td></tr>";
				}
				$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>"._("Add a new distro")."</a></p>";
			}
			break;
		case '1':
			// Добавление нового дистрибутива
			$dtype =& $db->query("SELECT * FROM dtype");
			$type = "<select name='distType'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $type .= "<option value='".$dtinfo["type_id"]."'>".$secure->stripStr($dtinfo["type"])."</option>";
			}
			$type .= "</select>\n";
			$display  = "<div class='modulename'><a href='admin.php?mode=1'>"._("Distributives")."</a> :: "._("Adding a new apt-distribution")."</div>";
			$display .= "<form action='./process.php' method='POST' enctype='multipart/form-data'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= _("Name of distro").": <input type='text' name='distName'><br>\n";
			$display .= _("User-Agent's string").": <input type='text' name='distUA'><br>\n";
			$display .= _("Type of distro").": ".$type."<br>";
			$display .= _("Logo of distro (Transparent PNG)").": <input type='file' name='distLOGO'><br>";
			$display .= "<input type='submit' value='"._("Create")."'></form>\n";
			break;
		case '2':
			// Правка существующего дистрибутива
			$dist =& $db->query("SELECT * FROM distribution WHERE dist_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$dtype =& $db->query("SELECT * FROM dtype");
			$type = "<select name='distType'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    if ($info["disttype"]==$dtinfo["type_id"]) {
				$type .= "<option value='".$dtinfo["type_id"]."' selected>".$secure->stripStr($dtinfo["type"])."</option>";
			    } else {
				$type .= "<option value='".$dtinfo["type_id"]."'>".$secure->stripStr($dtinfo["type"])."</option>";
			    }
			}
			$type .= "</select>\n";
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>"._("Distributives")."</a> :: "._("Editing apt-distribution")." <em class='".$secure->stripStr($info["distua"])."-em'>".$secure->stripStr($info["distname"])."</em></div>";
			$display .= "<form action='./process.php' method='POST' enctype='multipart/form-data'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='distID' value='$uid'>\n";
			$display .= _("Name of distro").": <input type='text' name='distName' value='".$secure->stripStr($info["distname"])."'><br>\n";
			$display .= _("User-Agent's string").": <input type='text' name='distUA' value='".$secure->stripStr($info["distua"])."'><br>\n";
			$display .= _("Type of distro").": ".$type."<br>";
			$display .= _("Logo of distro (Transparent PNG)").": <input type='file' name='distLOGO'><br>";
			$display .= "<input type='submit' value='"._("Edit")."'></form>\n";
			break;
		case '3':
			// Удаление существующего дистрибутива
			$dist =& $db->query("SELECT * FROM distribution WHERE dist_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>"._("Distributives")."</a> :: "._("Removal of apt-distribution")." <em class='".$secure->stripStr($info["distua"])."-em'>".$secure->stripStr($info["distname"])."</em></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='distID' value='$uid'>\n";
			$display .= "<input type='hidden' name='distUA' value='".$secure->stripStr($info["distua"])."'>\n";
			$display .= "<input type='submit' value='"._("Remove")."'></form>\n";
			break;
	    }
	    break;
	case '2':
	    // Работа с версиями дистрибутивов
	    switch ($act) {
		case '0':
			// Все версии имеющихся дистрибутивов
			$dist =& $db->query("SELECT * FROM distribution d JOIN version v ON d.dist_id=v.dist_id ORDER BY d.dist_id,v.version ASC");
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
			$display .= "<table><tr><th>".("Version")."</th><th>"._("Action")."</th></tr>\n";
			while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
			    $display .= "<tr><td>".$secure->stripStr($info["distname"])." ".$secure->stripStr($info["version"])." &#8220;".$secure->stripStr($info["vname"])."&#8221;</td>\n";
			    $display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$info["version_id"]."' class='edit'><img title='"._("Edit")."' src='$imgdir/edit.png' width='16' height='16'></a>";
			    $display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$info["version_id"]."' class='delete'><img title='"._("Remove")."' src='$imgdir/delete.png' width='16' height='16'></a></td></tr>\n";
			}
			$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>"._("Add a new version of distro")."</a></p>\n";
			break;
		case '1':
			// Добавление новой версии дистрибутива
			$dtype =& $db->query("SELECT * FROM distribution");
			$type = "<select name='distName'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $type .= "<option value='".$dtinfo["dist_id"]."'>".$secure->stripStr($dtinfo["distname"])."</option>";
			}
			$type .= "</select>\n";
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>"._("Versions")."</a> :: "._("Editiong version of distribution")."</div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= _("Version number").": <input type='text' name='versNum'><br>\n";
			$display .= _("Version name").": <input type='text' name='versNam'><br>\n";
			$display .= _("Version codename").": <input type='text' name='versCN'><br>\n";
			$display .= _("Distribution").": ".$type."<br>";
			$display .= "<input type='submit' value='"._("Create")."'></form>\n";
			break;
		case '2':
			// Правка имеющейся версии дистрибутива
			$vers =& $db->query("SELECT * FROM version v JOIN distribution d ON d.dist_id=v.dist_id WHERE version_id='$uid'");
			$vers->fetchInto($info, DB_FETCHMODE_ASSOC); 
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>"._("Versions")."</a> :: "._("Adding a new version of distribution")." <em>".$secure->stripStr($info["distname"])."</em></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='versID' value='$uid'>\n";
			$display .= _("Version number").": <input type='text' name='versNum' value='".$secure->stripStr($info["version"])."'><br>\n";
			$display .= _("Version name").": <input type='text' name='versNam' value='".$secure->stripStr($info["vname"])."'><br>\n";
			$display .= _("Version codename").": <input type='text' name='versCN' value='".$secure->stripStr($info["vcodename"])."'><br>\n";
			$display .= "<input type='submit' value='"._("Edit")."'></form>\n";
			break;
		case '3':
			// Удаление существующей версии дистрибутива
			$dist =& $db->query("SELECT * FROM version v JOIN distribution d ON v.dist_id=d.dist_id WHERE v.version_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>"._("Versions")."</a> :: "._("Removal version of distribution")." ".$secure->stripStr($info["version"])." (&#8220;".$secure->stripStr($info["vname"])."&#8221;) <em>".$secure->stripStr($info["distname"])."</em></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='versID' value='$uid'>\n";
			$display .= "<input type='submit' value='"._("Remove")."'></form>\n";
			break;
	    }
	    break;
	case '3':
	    // Работа с источниками репозиториев
	    switch ($act) {
		case '0':
			// Список источников
			$orig =& $db->query("SELECT * FROM origin");
			if ($orig->numRows()>0) {
				$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
				$display .= "<table><tr><th>Источник</th><th>Действие</th></tr>\n";
				while ($orig->fetchInto($info, DB_FETCHMODE_ASSOC)) {
				    $distlist = substr($distlist, 0, -2);
				    $display .= "<tr><td>".$secure->stripStr($info["origin"])."</td>\n";
				    $display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$info["orig_id"]."' class='nodec'><img src='$imgdir/edit.png' width='16' height='16' title='Редактировать'></a>";
				    $display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$info["orig_id"]."'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td>\n";
				    $display .= "</tr>";
				}
			}
			$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>Добавить источник репозиториев</a></p>\n";
			break;
		case '1':
			// Добавление нового источника
			$display = "<div class='modulename'>Справочники :: <a href='admin.php?mode=".$mode."'>Источники</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Добавление</a></div>";
			$display .= "<form action='./process.php' method='POST' enctype='multipart/form-data'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "Название источника: <input type='text' name='origin'><br>\n";
			$display .= "<input type='submit' value='Добавить'></form>\n";
			break;
		case '2':
			// Правка существующего источника
			$orig =& $db->query("SELECT * FROM origin WHERE orig_id='$uid'");
			$orig->fetchInto($info, DB_FETCHMODE_ASSOC);
			$type .= "</select>\n";
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Источники</a> :: Правка источника репозиториев <em>'".$secure->stripStr($info["origin"])."'</em></div>";
			$display .= "<form action='./process.php' method='POST' enctype='multipart/form-data'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='originID' value='$uid'>\n";
			$display .= "Название источника: <input type='text' name='origin' value='".$secure->stripStr($info["origin"])."'><br>\n";
			$display .= "<input type='submit' value='Править'></form>\n";
			break;
		case '3':
			// Удаление существующего источника
			$orig =& $db->query("SELECT * FROM origin WHERE orig_id='$uid'");
			$orig->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Источники</a> :: Удаление источника репозиториев <em>'".$secure->stripStr($info["origin"])."'</em></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='originID' value='$uid'>\n";
			$display .= "<input type='submit' value='Удалить'></form>\n";
			break;
	    }
	    break;
        case '4':
            // Работа с репозиториями
            switch ($act) {
                case '0':
                        // Выбор дистрибутива
			$dist =& $db->query("SELECT * FROM `repository` LEFT JOIN origin ON repository.orig_id=origin.orig_id LEFT JOIN root ON repository.root_id=root.root_id");
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
			$display .= "<table><tr><th>Репозиторий</th><th>Действие</th><th>Корень</th><th>Источник</th></tr>\n";
			while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
			    $display .= "<tr><td>".$info["repname"]."</td>";
			    $display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$info["rep_id"]."' class='nodec'><img src='$imgdir/edit.png' width='16' height='16' title='Редактировать'></a>";
			    $display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$info["rep_id"]."'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td>\n";
			    $display .= "<td>".$info["root_folder"]."</td>";
			    $display .= "<td>".$info["origin"]."</td></tr>";
			}
                        $display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1&uid=".$uid."'><img src='$imgdir/add.png' width='16' height='16'>Добавить новый репозиторий</a></p>";
                        break;
                case '1':
                        // Новый репозиторий
			$mirr =& $db->query("SELECT * FROM mirror");
			$mirror = "";
			while($mirr->fetchInto($gm, DB_FETCHMODE_ASSOC)) {
				$mirror .= "<input type='checkbox' name='repMirror' value='".$gm["mirror_id"]."'> ".$secure->stripStr($gm["mname"])." ";
			}
                        $rep =& $db->query("SELECT * FROM distribution d JOIN version v ON v.dist_id=d.dist_id WHERE v.version_id='$uid'");
                        $rep->fetchInto($dist, DB_FETCHMODE_ASSOC);
                        $dist_id = $dist["dist_id"];
                        $dist_vname = $secure->stripStr($dist["distname"])." ".$secure->stripStr($dist["version"])." &#8220;".$secure->stripStr($dist["vname"])."&#8221;";
			$dtype =& $db->query("SELECT * FROM scheme");
			$rscheme = "<select name='scheme'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $rscheme .= "<option value='".$dtinfo["scheme_id"]."'>".$secure->stripStr($dtinfo["scheme"])."</option>";
			}
			$rscheme .= "</select>";
			$origin_q =& $db->query("SELECT * FROM origin");
			$origin = "<select name='origin'>";
			while ($origin_q->fetchInto($origin_info, DB_FETCHMODE_ASSOC)) {
			    $origin .= "<option value='".$origin_info["orig_id"]."'>".$secure->stripStr($origin_info["origin"])."</option>";
			}
			$origin .= "</select>\n";
                        $sect =& $db->query("SELECT * FROM section s JOIN sect2dist d ON d.sect_id=s.sect_id WHERE d.dist_id='$dist_id'");
                        $list = "";
                        while ($sect->fetchInto($slist, DB_FETCHMODE_ASSOC)) {
                            $list .= "<input type='checkbox' name='sect[]' value='".$slist["sect_id"]."'> <span title='".$secure->stripStr($slist["sectinfo"])."'>".$secure->stripStr($slist["sectname"])."</span> ";
                        }
			$type .= "</select>\n";
			$rootfolder = "<select name='rootFolder'>\n";
			$root =& $db->query("SELECT * FROM root");
			while ($root->fetchInto($rfi, DB_FETCHMODE_ASSOC)) {
				$rootfolder .= "<option value='".$rfi["root_id"]."'>".$secure->stripStr($rfi["root_folder"])."</option>";
			}
			$rootfolder .= "</select>";
			$display = "<div class='modulename'>Управление :: <a href='admin.php?mode=".$mode."'>Репозитории</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Добавление</a></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='vers' value='$uid'>\n";
			$display .= "Название репозитория (codename): <input type='text' name='repName'><br>\n";
			$display .= "Описание репозитория:<br> <textarea name='repInfo'></textarea><br>\n";
                        $display .= "Схема репозитория: ".$rscheme."<br>";
			$display .= _("Mirrors").": ".$mirror."<br>";
			$display .= "Источник репозитория: ".$origin."<br>";
			$display .= "Корневая папка репозитория: ".$rootfolder."<br>";
			$display .= "Секции: ".$list."<br>";
			$display .= "По умолчанию: <input type='checkbox' name='default' value='1'>";
			$display .= "<br><input type='submit' value='Создать'></form>\n";
                        break;
                case '2':
            		// Редактирование репозитория
			$rep =& $db->query("SELECT * FROM repository r JOIN ver2rep l ON l.rep_id=r.rep_id JOIN version v ON v.version_id=l.ver_id JOIN distribution d ON v.dist_id=d.dist_id JOIN root r2 ON r2.root_id=r.root_id WHERE r.rep_id='$uid'");
            		$rep->fetchInto($info, DB_FETCHMODE_ASSOC);
			$dist_vname = $secure->stripStr($info["distname"])." ".$secure->stripStr($info["version"])." &#8220;".$secure->stripStr($info["vname"])."&#8221;";
            		$tlist = "<select name='scheme'>";
            		$sq =& $db->query("SELECT * FROM scheme");
            		while ($sq->fetchInto($type, DB_FETCHMODE_ASSOC)) {
            		    if ($type["scheme_id"]==$info["scheme_id"]) {
            			$tlist .= "<option value='".$type["scheme_id"]."' selected>".$secure->stripStr($type["scheme"])."</option>";
            		    } else {
            			$tlist .= "<option value='".$type["scheme_id"]."'>".$secure->stripStr($type["scheme"])."</option>";
            		    }
            		}
			$tlist .= "</select>";
			$mlist = "";
			$mq =& $db->query("SELECT * FROM mirror m JOIN mirr2rep r ON m.mirror_id=r.mirror_id WHERE r.rep_id='$uid'");
			if ($mq->numRows()>0) {
				while ($mq->fetchInto($mget, DB_FETCHMODE_ASSOC)) {
					$mlist .= "<input type='checkbox' name='repMirror' value='".$mget["mirror_id"]."' checked> ".$secure->stripStr($mget["mname"])." ";
				}
			}
			$mq =& $db->query("SELECT m.* FROM mirror m WHERE m.mirror_id NOT IN (SELECT mirror_id FROM mirr2rep WHERE rep_id='$uid')");
			if ($mq->numRows()>0) {
				while ($mq->fetchInto($mget, DB_FETCHMODE_ASSOC)) {
						$mlist .= "<input type='checkbox' name='repMirror' value='".$mget["mirror_id"]."'> ".$secure->stripStr($mget["mname"])." ";
					}
			}

			$tlist2 = "<select name='origin'>";
			$sq =& $db->query("SELECT * FROM origin");
            		while ($sq->fetchInto($type, DB_FETCHMODE_ASSOC)) {
            		    if ($type["orig_id"]==$info["orig_id"]) {
            			$tlist2 .= "<option value='".$type["orig_id"]."' selected>".$secure->stripStr($type["origin"])."</option>";
            		    } else {
            			$tlist2 .= "<option value='".$type["orig_id"]."'>".$secure->stripStr($type["origin"])."</option>";
            		    }
            		}
            		$tlist2 .= "</select>";
            		$list = "";
            		$req =& $db->query("SELECT * FROM section s JOIN sect2rep r ON s.sect_id=r.sect_id WHERE r.rep_id='$uid'");
            		if ($req->numRows()>0) {
            		    while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
            			$list .= "<input type='checkbox' name='sect[]' value='".$sect["sect_id"]."' checked><span title='".$secure->stripStr($sect["sectinfo"])."'>".$secure->stripStr($sect["sectname"])."</span> ";
            		    }
            		}
            		$req =& $db->query("SELECT s.* FROM section s WHERE s.sect_id NOT IN (SELECT sect_id FROM sect2rep WHERE rep_id='$uid')");
            		if ($req->numRows()>0) {
            		    while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
            			$list .= "<input type='checkbox' name='sect[]' value='".$sect["sect_id"]."'><span title='".$secure->stripStr($sect["sectinfo"])."'>".$secure->stripStr($sect["sectname"])."</span> ";
            		    }
            		}
			$rootfolder = "<select name='rootFolder'>\n";
			$req =& $db->query("SELECT * FROM root");
			if ($req->numRows()>0) {
				while ($req->fetchInto($rfi, DB_FETCHMODE_ASSOC)) {
					if ($rfi["root_id"]==$info["root_id"]) {
						$rootfolder .= "<option value='".$rfi["root_id"]."' selected>".$secure->stripStr($rfi["root_folder"])."</option>";
					} else {
						$rootfolder .= "<option value='".$rfi["root_id"]."'>".$secure->stripStr($rfi["root_folder"])."</option>";
					}
				}
			}
			$rootfolder .= "</select>";
			
			if ($info["defaultrep"]==1){$ch="checked";} else{$ch="";}

			$display = "<div class='modulename'>Управление :: <a href='admin.php?mode=".$mode."'>Репозитории</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Правка : ".$info["repname"]."</a></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value=".$mode.">\n";
			$display .= "<input type='hidden' name='act' value=".$act.">\n";
			$display .= "<input type='hidden' name='rep' value='$uid'>\n";
			$display .= "Название репозитория (codename): <input type='text' name='repName' value='".$secure->stripStr($info["repname"])."'><br>\n";
			$display .= "Описание репозитория:<br> <textarea name='repInfo'>".$secure->stripStr($info["repdescribe"])."</textarea><br>\n";
                        $display .= "Схема репозитория: ".$tlist."<br>";
			$display .= "Источник репозитория: ".$tlist2."<br>";
			$display .= _("Mirrors").": ".$mlist."<br>";
			$display .= "Корневая папка репозитория: ".$rootfolder."<br>";
			$display .= "Секции: ".$list."<br>";
			$display .= "По умолчанию: <input type='checkbox' name='default' value='1' ".$ch.">";
			$display .= "<br><input type='submit' value='Править'></form>\n";
		break;
            	case '3':
            		// Удаление репозитория
			$rep =& $db->query("SELECT * FROM repository r JOIN ver2rep l ON l.rep_id=r.rep_id JOIN version v ON v.version_id=l.ver_id JOIN distribution d ON v.dist_id=d.dist_id WHERE r.rep_id='$uid'");
            		$rep->fetchInto($info, DB_FETCHMODE_ASSOC);
			$dist_vname = $secure->stripStr($info["distname"])." ".$secure->stripStr($info["version"])." &#8220;".$secure->stripStr($info["vname"])."&#8221;";
			$display = "<div class='modulename'>Управление :: <a href='admin.php?mode=".$mode."'>Репозитории</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Удаление : ".$info["repname"]."</a></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='rep' value='$uid'>\n";
			$display .= "<input type='submit' value='Удалить'></form>\n";
		break;
            }
            break;
        case '5':
            // Управление разделами
            switch ($act) {
        	case '0':
        		// Список секций
        		$req =& $db->query("SELECT * FROM section");
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
        		$display .= "<table><tr><th>Раздел</th><th>Действие</th><th>Используется в</th></tr>\n";
        		while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
        		    $replist = "";
        		    $sreq =& $db->query("SELECT * FROM distribution d JOIN sect2dist s ON s.dist_id=d.dist_id WHERE s.sect_id='".$sect["sect_id"]."'");
        		    while ($sreq->fetchInto($rep, DB_FETCHMODE_ASSOC)) {
        			$replist .= "<em>".$secure->stripStr($rep["distname"])."</em>, ";
        		    }
        		    $replist = substr($replist, 0, -2);
        		    $display .= "<tr><td>".$secure->stripStr($sect["sectname"])."</td>";
        		    $display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$sect["sect_id"]."' class='edit'><img title='Редактировать' src='$imgdir/edit.png' width='16' height='16'></a>";
        		    $display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$sect["sect_id"]."' class='delete'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td>";
        		    $display .= "<td>".$replist."</td></tr>";
        		}
        		$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>Добавить секцию</a></p>";
        		break;
        	case '1':
        		$req =& $db->query("SELECT * FROM distribution");
        		while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        		    $list .= "<br><input type='checkbox' name='dist' value='".$dist["dist_id"]."'>".$secure->stripStr($dist["distname"])." ";
        		}
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Секции</a> :: Создание секции репозитория</div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "Название секции (codename): <input type='text' name='sectName'><br>\n";
			$display .= "Описание секции:<br> <textarea name='sectInfo'></textarea><br>\n";
                        $display .= "Используется в дистрибутивах: ".$list;
			$display .= "<br><input type='submit' value='Добавить'></form>\n";
        		break;
        	case '2':
        		$req =& $db->query("SELECT * FROM distribution d JOIN sect2dist s ON s.dist_id=d.dist_id WHERE s.sect_id='$uid'");
        		if ($req->numRows()>0) {
            		    while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        			$list .= "<br><input type='checkbox' name='dist[]' value='".$dist["dist_id"]."' checked>".$secure->stripStr($dist["distname"])." ";
        		    }
        		}
        		$req =& $db->query("SELECT d.* FROM distribution d WHERE dist_id NOT IN (SELECT dist_id FROM sect2dist WHERE sect_id='$uid')");
        		if ($req->numRows()>0) {
        		    while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        			$list .= "<br><input type='checkbox' name='dist[]' value='".$dist["dist_id"]."'>".$secure->stripStr($dist["distname"])." ";
        		    }
        		}
        		$req =& $db->query("SELECT * FROM section WHERE sect_id='$uid'");
        		$req->fetchInto($sect, DB_FETCHMODE_ASSOC);
			$display = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Секции</a> :: Правка секции репозитория</div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='sectID' value='$uid'>\n";
			$display .= "Название секции (codename): <input type='text' name='sectName' value='".$secure->stripStr($sect["sectname"])."'><br>\n";
			$display .= "Описание секции:<br> <textarea name='sectInfo'>".$secure->stripStr($sect["sectinfo"])."</textarea><br>\n";
                        $display .= "Используется в дистрибутивах: ".$list;
			$display .= "<br><input type='submit' value='Править'></form>\n";
        		break;
        	case '3':
        		$req =& $db->query("SELECT * FROM section WHERE sect_id='$uid'");
        		$req->fetchInto($sect, DB_FETCHMODE_ASSOC);
			$display = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Секции</a> :: Удаление секции <em>".$secure->stripStr($sect["sectname"])."</em></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='sectID' value='$uid'>\n";
			$display .= "<br><input type='submit' value='Удалить'></form>\n";
        		break;
            }
            break;
	case '6':
	    // Управление схемами репозиториев
	    switch ($act) {
		case '0':
			// Список схем
			$req =& $db->query("SELECT * FROM scheme");
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
        		$display .= "<table><th>Схема</th><th>Действие</th></tr>";
        		while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
        			$display .= "<tr><td>".$secure->stripStr($sect["scheme"])."</td>";
        			$display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$sect["scheme_id"]."' class='edit'><img title='Редактировать' src='$imgdir/edit.png' width='16' height='16'></a>";
        			$display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$sect["scheme_id"]."' class='delete'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td></tr>";
        		}
        		$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>Добавить новую схему</a></p>";
			break;
		case '1':
			// Добавление новой схемы
			$display  = "<div class='modulename'><a href='admin.php?mode=5'>Схемы</a> :: Создание схемы репозитория</div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "Схема репозитория: <input type='text' name='scheme'><br>\n";
			$display .= "<input type='submit' value='Добавить'></form>\n";
			break;
		case '2':
			// Правка существующей схемы
			$req =& $db->query("SELECT * FROM scheme WHERE scheme_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($scheme, DB_FETCHMODE_ASSOC);
				$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Схемы</a> :: Правка схемы репозитория</div>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='schemeID' value='".$secure->stripStr($scheme["scheme_id"])."'><br>\n";
				$display .= "Схема репозитория: <input type='text' name='scheme' value='".$secure->stripStr($scheme["scheme"])."'><br>\n";
				$display .= "<input type='submit' value='Править'></form>\n";
			} else {
				$display = "Такой схемы репозитория не существует";
			}
			break;
		case '3':
			// Удаление существующей схемы
			$req =& $db->query("SELECT * FROM scheme WHERE scheme_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($scheme, DB_FETCHMODE_ASSOC);
				$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Схемы</a> :: Удаление схемы репозитория</div>";
				$display .= "Удаляемая схема: ".$secure->stripStr($scheme["scheme"])."<br>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='schemeID' value='".$scheme["scheme_id"]."'><br>\n";
				$display .= "<input type='submit' value='Удалить'></form>\n";
			} else {
				$display = "Такой схемы репозитория не существует";
			}
			break;
	    }
	    break;
	case '7':
	    // Управление типами репозиториев
	    switch ($act) {
		case '0':
			// Список типов репозиториев
			$req =& $db->query("SELECT * FROM rtype");
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
			$display .= "<table><tr><th>Тип</th><th>Действие</th></tr>";
			if ($req->numRows()>0) {
				while ($req->fetchInto($setting, DB_FETCHMODE_ASSOC)) {
					$display .= "<tr><td>".$secure->stripStr($setting["rtype"])."</td>";
					$display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$setting["rtype_id"]."' class='edit'><img title='Редактировать' src='$imgdir/edit.png' width='16' height='16'></a>";
					$display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$setting["rtype_id"]."' class='delete'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td></tr>";
				}
			}
        		$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>Добавить новый тип репозитория</a></p>";
			break;
		case '1':
			// Добавление нового типа репозитория
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Типы репозиториев</a> :: Создание нового типа репозитория</div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "Тип: <input type='text' name='rtype'><br>\n";
			$display .= "<input type='submit' value='Добавить'></form>\n";
			break;
		case '2':
			// Правка существующего типа репозитория
			$req =& $db->query("SELECT * FROM rtype WHERE rtype_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($setting, DB_FETCHMODE_ASSOC);
				$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Типы репозиториев</a> :: Правка типа репозитория</div>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='rtypeID' value='".$secure->stripStr($setting["rtype_id"])."'><br>\n";
				$display .= "Тип: <input type='text' name='rtype' value='".$secure->stripStr($setting["rtype"])."'><br>\n";
				$display .= "<input type='submit' value='Править'></form>\n";
			} else {
				$display = "Такого типа репозитория не существует";
			}
			break;
		case '3':
			// Удаление существующего типа репозитория
			$req =& $db->query("SELECT * FROM rtype WHERE rtype_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($setting, DB_FETCHMODE_ASSOC);
				$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Типы репозиториев</a> :: Удаление существующего типа репозитория</div>";
				$display .= "Удаляемый тип <em>".$secure->stripStr($setting["rtype"])."</em><br>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='rtypeID' value='".$setting["rtype_id"]."'><br>\n";				
				$display .= "<input type='submit' value='Удалить'></form>\n";
			} else {
				$display = "Такого типа репозитория не существует";
			}
			break;
	    }
	    break;
	case '8':
	    // Управление корневыми папками репозиториев
	    switch ($act) {
		case '0':
			// Список корневых папок репозиториев
			$req =& $db->query("SELECT * FROM root");
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
			$display .= "<table><tr><th>Путь</th><th>Действие</th></tr>\n";
			if ($req->numRows()>0) {
			    $display .= "<ul>\n";
			    while ($req->fetchInto($root, DB_FETCHMODE_ASSOC)) {
				$display .= "<tr><td>".$secure->stripStr($root["root_folder"])."</td>";
				$display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$root["root_id"]."' class='edit'><img title='Редактировать' src='$imgdir/edit.png' width='16' height='16'></a>";
				$display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$root["root_id"]."' class='delete'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td></tr>";
			    }
				$display .= "</table>\n";
			} else {
				$display .= "<p>Ни одной корневой папки не найдено.</p>";
			}
			$display .= "<p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>Добавить новую корневую папку репозиториев</a></p>";
			break;
		case '1':
			// Добавление новой корневой папки репозиториев
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Корневые пути</a> :: Добавление корневой папки</div>";
			$display .= "<form action='./process.php' method='post'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "Корневая папка: <input type='text' name='rootFolder'><br>\n";
			$display .= "<input type='submit' value='Создать'>\n</form>\n";
			break;
		case '2':
			// Редактирование корневой папки репозиториев
			$display = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Корневые пути</a> :: Редактирование корневой папки</div>";
			$req =& $db->query("SELECT * FROM root WHERE root_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($root, DB_FETCHMODE_ASSOC);
				$display .= "<form action='./process.php' method='post'>\n";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='rootID' value='$uid'>\n";
				$display .= "Корневая папка репозитория: <input type='text' name='rootFolder' value='".$secure->stripStr($root["root_folder"])."'><br>\n";
				$display .= "<input type='submit' value='Редактировать'>\n</form>\n";
			} else {
				$display .= "<p>Такой корневой папки репозиториев не существует</p>";
			}
			break;
		case '3':
			// Удаление корневой папки репозиториев
			$display = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Корневые пути</a> :: Удаление корневой папки</div>";
			$req =& $db->query("SELECT * FROM root WHERE root_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($root, DB_FETCHMODE_ASSOC);
				$display .= "<form action='./process.php' method='post'>\n";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='rootID' value='$uid'>\n";
				$display .= "Корневая папка репозитория: <input type='text' name='rootFolder' value='".$secure->stripStr($root["root_folder"])."' readonly><br>\n";
				$display .= "<input type='submit' value='Удалить'>\n</form>\n";
			} else {
				$display .= "<p>Такой корневой папки не существует</p>";
			}
			break;
	    }
	break;
	case '9':
	    // Работа с зеркалами репозиториев
	    switch ($act) {
		case '0':
			// Список зеркал
			$mirr =& $db->query("SELECT * FROM mirror");
			if ($mirr->numRows()>0) {
				$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
				$display .= "<table><tr><th>Зеркало</th><th>Действие</th></tr>\n";
				while ($mirr->fetchInto($info, DB_FETCHMODE_ASSOC)) {
				    $display .= "<tr><td>".$secure->stripStr($info["mname"])."</td>\n";
				    $display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$info["mirror_id"]."' class='nodec'><img src='$imgdir/edit.png' width='16' height='16' title='Редактировать'></a>";
				    $display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$info["mirror_id"]."'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td>\n";
				    $display .= "</tr>";
				}
			}
			$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>Добавить зеркало репозиториев</a></p>\n";
			break;
		case '1':
			// Добавление нового зеркала
			$display = "<div class='modulename'>Справочники :: <a href='admin.php?mode=".$mode."'>Зеркала</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Добавление</a></div>";
			$display .= "<form action='./process.php' method='POST' enctype='multipart/form-data'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "Название зеркала: <input type='text' name='mname'><br>\n";
			$display .= "URL зеркала: <input type='text' name='murl'><br>\n";
			$display .= "<input type='submit' value='Добавить'></form>\n";
			break;
		case '2':
			// Правка существующего зеркала
			$mirr =& $db->query("SELECT * FROM mirror WHERE mirror_id='$uid'");
			$mirr->fetchInto($info, DB_FETCHMODE_ASSOC);
			$type .= "</select>\n";
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Зеркала</a> :: Правка зеркала репозиториев <em>'".$secure->stripStr($info["mname"])."'</em></div>";
			$display .= "<form action='./process.php' method='POST' enctype='multipart/form-data'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='mirrorID' value='$uid'>\n";
			$display .= "Название источника: <input type='text' name='mname' value='".$secure->stripStr($info["mname"])."'><br>\n";
			$display .= "URL источника: <input type='text' name='murl' value='".$secure->stripStr($info["mproto"]).$secure->stripStr($info["murl"])."'><br>\n";
			$display .= "<input type='submit' value='Править'></form>\n";
			break;
		case '3':
			// Удаление существующего зеркала
			$orig =& $db->query("SELECT * FROM mirror WHERE mirror_id='$uid'");
			$orig->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<div class='modulename'><a href='admin.php?mode=".$mode."'>Зеркала</a> :: Удаление зеркала репозиториев <em>'".$secure->stripStr($info["mname"])."'</em></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "<input type='hidden' name='mirrorID' value='$uid'>\n";
			$display .= "<input type='submit' value='Удалить'></form>\n";
			break;
	    }
	    break;
	case '20':
	    // Управление опциями Ant
	    switch ($act) {
		case '0':
			// Список опций Ant
			$req =& $db->query("SELECT * FROM settings");
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
			$display .= "<table><tr><th>Опция</th><th>Действие</th><th>Значение</th></tr>";
			if ($req->numRows()>0) {
				while ($req->fetchInto($setting, DB_FETCHMODE_ASSOC)) {
					$display .= "<tr><td>".$secure->stripStr($setting["opt"])."</td>";
					$display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$setting["opt_id"]."'><img title='Редактировать' src='$imgdir/edit.png' width='16' height='16'></a>";
					$display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$setting["opt_id"]."' class='delete'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td>";
					$display .= "<td>".$secure->stripStr($setting["optvalue"])."</td></tr>";
				}
			}
        		$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>Добавить новую опцию</a></p>";
			break;
		case '1':
			// Добавление новой опции Ant
			$display = "<div class='modulename'>Настройки :: <a href='admin.php?mode=".$mode."'>Опции</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Добавление</a></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "Настройка (латиница, без пробелов): <input type='text' name='setoption'><br>\n";
			$display .= "Свойство (значение) настройки: <input type='text' name='setvalue'><br>\n";
			$display .= "<input type='submit' value='Добавить'></form>\n";
			break;
		case '2':
			// Правка существующей опции Ant
			$req =& $db->query("SELECT * FROM settings WHERE opt_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($setting, DB_FETCHMODE_ASSOC);
				$display = "<div class='modulename'>Настройки :: <a href='admin.php?mode=".$mode."'>Опции</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Правка</a></div>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='optID' value='".$secure->stripStr($setting["opt_id"])."'><br>\n";
				$display .= "Настройка: <input type='text' name='setoption' value='".$secure->stripStr($setting["opt"])."' readonly><br>\n";
				if ($setting["opt"]=="interface") {
					$sq =& $db->query("SELECT * FROM interfaces");
					$setvalue = "<select name='setvalue'>";
					while ($sq->fetchInto($if, DB_FETCHMODE_ASSOC)) {
						if ($if["interface"]==$setting["optvalue"]) {
							$setvalue .= "<option value='".$secure->stripStr($if["interface"])."' selected>".$secure->stripStr($if["interfaceinfo"])."</option>\n";
						} else {
							$setvalue .= "<option value='".$secure->stripStr($if["interface"])."'>".$secure->stripStr($if["interfaceinfo"])."</option>\n";
						}
					}
					$setvalue .= "</select>";
					$display .= "Свойство: ".$setvalue."<br>\n";
				} else {
					$display .= "Свойство: <input type='text' name='setvalue' value='".$secure->stripStr($setting["optvalue"])."'><br>\n";
				}
				$display .= "<input type='submit' value='Править'></form>\n";
			} else {
				$display = "Такой опции не существует";
			}
			break;
		case '3':
			// Удаление существующей опции Ant
			$req =& $db->query("SELECT * FROM settings WHERE opt_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($setting, DB_FETCHMODE_ASSOC);
				$display = "<div class='modulename'>Настройки :: <a href='admin.php?mode=".$mode."'>Опции</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Удаление</a></div>";
				$display .= "Удаляемая опция <em>".$secure->stripStr($setting["opt"])."</em> с свойством <em>".$secure->stripStr($setting["optvalue"])."</em><br>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='optID' value='".$setting["opt_id"]."'><br>\n";
				$display .= "<input type='submit' value='Удалить'></form>\n";
			} else {
				$display = "Такой опции не существует";
			}
			break;
		}
	    break;
	case '21':
	    // Управление интерфейсами
	    switch($act) {
		case '0':
			// Список интерфейсов
			$req =& $db->query("SELECT * FROM interfaces");
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
			$display .= "<table><tr><th>Интерфейс</th><th>Действие</th></tr>";
			if ($req->numRows()>0) {
			    while ($req->fetchInto($if, DB_FETCHMODE_ASSOC)) {
				$display .= "<tr><td>".$secure->stripStr($if["interfaceinfo"])." (".$secure->stripStr($if["interface"]).") </td>";
				$display .= "<td><a href='".$admin."?mode=".$mode."&action=2&uid=".$if["if_id"]."' class='edit'><img title='Редактировать' src='$imgdir/edit.png' width='16' height='16'></a>";
				$display .= "<a href='".$admin."?mode=".$mode."&action=3&uid=".$if["if_id"]."' class='delete'><img title='Удалить' src='$imgdir/delete.png' width='16' height='16'></a></td></tr>";
			    }
			}
			$display .= "</table><p><a href='".$admin."?mode=".$mode."&action=1'><img src='$imgdir/add.png' width='16' height='16'>Добавить новый интерфейс</a></p>";
			break;
		case '1':
			// Добавление нового интерфейса
			$display = "<div class='modulename'>Настройки :: <a href='admin.php?mode=".$mode."'>Интерфейсы</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Добавление</a></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='act' value='".$act."'>\n";
			$display .= "Интерфейс (имя файла): <input type='text' name='ifname'><br>\n";
			$display .= "Интерфейс (название): <input type='text' name='ifinfo'><br>\n";
			$display .= "<input type='submit' value='Добавить интерфейс'></form>\n";
			break;
		case '2':
			// Правка интерфейса
			$req =& $db->query("SELECT * FROM interfaces WHERE if_id='$uid'");
			$display = "<div class='modulename'>Настройки :: <a href='admin.php?mode=".$mode."'>Интерфейсы</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Правка</a></div>";
			if ($req->numRows()>0) {
				$req->fetchInto($if, DB_FETCHMODE_ASSOC);
				$display .= "<form action='./process.php' method='POST'>";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='if' value='$uid'>\n";
				$display .= "Интерфейс (имя файла): <input type='text' name='ifname' value='".$secure->stripStr($if["interface"])."'><br>\n";
				$display .= "Интерфейс (название): <input type='text' name='ifinfo' value='".$secure->stripStr($if["interfaceinfo"])."'><br>\n";
				$display .= "<input type='submit' value='Отредактировать'></form>\n";
			} else {
				$display .= "<p>Такого интерфейса не существует</p>";
			}
			break;
		case '3':
			// Удаление интерфейса
			$req =& $db->query("SELECT * FROM interfaces WHERE if_id='$uid'");
			$display = "<div class='modulename'>Настройки :: <a href='admin.php?mode=".$mode."'>Интерфейсы</a> :: <a href='admin.php?mode=".$mode."&act=".$act."'>Удаление</a></div>";
			if ($req->numRows()>0) {
				$req->fetchInto($if, DB_FETCHMODE_ASSOC);
				$display .= "<form action='./process.php' method='POST'>";
				$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
				$display .= "<input type='hidden' name='act' value='".$act."'>\n";
				$display .= "<input type='hidden' name='if' value='$uid'>\n";
				$display .= "Интерфейс (имя файла): <input type='text' name='ifname' value='".$secure->stripStr($if["interface"])."' readonly><br>\n";
				$display .= "Интерфейс (название): <input type='text' name='ifinfo' value='".$secure->stripStr($if["interfaceinfo"])."' readonly><br>\n";
				$display .= "<input type='submit' value='Удалить'></form>\n";
			}
			break;
	    }
	break;
	case '22':
	    // Управление паролем
	    switch($act) {
		case '0':
			// Смена пароля входа
			$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "<input type='hidden' name='mode' value='".$mode."'>\n";
			$display .= "Старый пароль: <input type='password' name='oldPW'><br>\n";
			$display .= "Новый пароль: <input type='password' name='newPW1'><br>\n";
			$display .= "Новый пароль (еще раз): <input type='password' name='newPW2'><br>\n";
			$display .= "<input type='submit' value='Сменить пароль'></form>\n";
			break;
			
	    break;
	    }
	break;
	case '23':
	    // Управление темами
	   	$display = "<div class='modulename'>".$menu_item[$mode]["title"]." :: <a href='admin.php?mode=".$mode."'>".$menu_item[$mode]["item"]."</a></div>";
		if (isset($_GET['chtheme'])){
		    $chtheme = $secure->wrapStr($_GET["chtheme"]);
		    $chicon  = $secure->wrapStr($_GET["chicon"]);
		    $theme->setTheme($chtheme,$chicon,$db);
		    $display.='<p style="color:red;">Тема измененна</p>';
		}
	   	$themename = $theme->getThemeName($core,$db);
                $iconsname = $theme->getIconSetName($core,$db);

                $display.= '<form action="admin.php" method="GET">';
	    	$display.= '<input type="hidden" name="mode" value="23">';
                $display.='<table>';
                $display.='<tr><td>Текущий стиль:</td><td><b>'.$themename.'</b></td><td>';
                $display.= '<select id="cht" name="chtheme">';
	   	$dis=$theme->getThemesList('style');
	    	foreach ($dis as $thm){
			    if($themename==$thm){
                                $display.= '<option selected>'.$thm.'</option>';
                            }else{
                                $display.= '<option>'.$thm.'</option>';
                            }
		    }
		$display.= '</select></td></tr>';
                $display.='<tr><td>Текущий набор иконок:</td><td><b>'.$iconsname.'</b></td><td>';
		$display.= '<select id="chi" name="chicon">';
	   	$dis=$theme->getThemesList('icon');
	    	foreach ($dis as $thm){
                    if($iconsname==$thm){
                        $display.= '<option selected>'.$thm.'</option>';
                    }else{
                        $display.= '<option>'.$thm.'</option>';
                    }
		}
		    $display.= '</select></td></tr></table>';
		    $display.= '<button type="submit">Сменить тему</button>';
		    $display.= '</form>';
	    break;
	break;
}


$display .= "</div></div>";

$smarty->assign('feedaddr',$_SERVER["HTTP_HOST"].dirname($_SERVER["PHP_SELF"]));
$smarty->assign('error',$error);
$smarty->assign('header',$header);
$smarty->assign('login',$login);
$smarty->assign('menu',$menu);
$smarty->assign('display',$display);
$smarty->assign('antversion',$core->getSetting('version',$db));
$smarty->assign('title',$core->getSetting('codename',$db));
$smarty->assign('style',$core->getCSSList($db));
$smarty->assign('theme',$theme->getThemeName($core,$db));
$smarty->display('admin.tpl');


?>
